<template lang='pug'>
#app(lang="pug")
  q-layout
    q-page-container
      q-toolbar.bg-primary.text-white
        q-toggle(v-model="demo", color="secondary") Editor/Demo Mode
        q-space
        div Meeting ID: {{ context.meetingid }}
        q-space
        div Sequence ID: {{ context.sequenceid }}
      q-page(padding, v-if="loading")
        q-spinner(size="sm")
      q-page(padding, v-else-if="noExports")
        .column
          .text Your plugin has no exports.  The top level package.json file needs to contain a "zoomsense" entry which includes an "exports" field, an array of strings listing which of the following components the plugin implements and exports:
            ul
              li Configuration
              li Dashboard
              li Overlay
              li Breakout
      q-page(padding, v-else-if="user")
        .column
          .col.full-width
            div(v-if="hasComp('Dashboard')")
              .text-h6 Dashboard Control
              q-card(flat)
                Dashboard(
                  :firebase="db",
                  :functions="functions",
                  :context="context",
                  :demo="demo",
                  :storage="storage"
                )
            div(v-if="hasComp('Breakout')")
              .text-h6 Room Control
              MeetingDetailsDynamic(
                :meetingId="context.meetingid",
                :context="context",
                :functions="functions",
                :firebase="db"
              )

            div(v-if="hasComp('Overlay')")
              .text-h6 Overlay
              .widescreen
                Overlay(
                  :demo="demo",
                  :firebase="db",
                  :functions="functions",
                  :context="context"
                )
</template>

<script lang='ts'>
import Vue from "vue";
import * as firebase from "firebase/app";
import "firebase/database";
import "firebase/functions";
import "firebase/auth";
import "firebase/storage";
import MeetingDetailsDynamic from "./MeetingDetailsDynamic.vue";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase";

const productionRtdbUrl = "https://zoomsense-plugin-default-rtdb.firebaseio.com/";

const app = firebase.initializeApp({
  apiKey: process.env.VUE_APP_APIKEY,
  databaseURL: process.env.VUE_APP_DATABASEURL || productionRtdbUrl,
  projectId: process.env.VUE_APP_PROJECTID || "zoomsense-plugin",
});

const db = new ZoomSenseClientFirebaseDB(app.database());
if (process.env.VUE_APP_FUNCTIONSURL) {
  app.functions().useFunctionsEmulator(process.env.VUE_APP_FUNCTIONSURL);
}
const functions = app.functions();
const storage = app.storage();
const auth = app.auth();

export default Vue.extend({
  name: "App",
  components: { MeetingDetailsDynamic },
  data() {
    return {
      db,
      functions,
      storage,
      plugin: process.env.VUE_APP_COMPONENTS,
      context: {
        meetingid: process.env.VUE_APP_MEETINGID,
        meetingId: process.env.VUE_APP_MEETINGID,
        sequenceid: process.env.VUE_APP_SEQUENCEID,
        sequenceId: process.env.VUE_APP_SEQUENCEID,
        userId: auth.currentUser?.uid,
      },
      loading: true,
      demo: false,
      user: null as null | firebase.auth.UserCredential,
      pluginPackage: undefined as undefined | { exports?: string[] },
    };
  },
  async mounted() {
    //do google login:
    await auth.signOut();
    try {
      this.user = await auth.signInWithEmailAndPassword(
        process.env.VUE_APP_EMAIL!,
        process.env.VUE_APP_PASSWORD!
      );
      this.context.userId = auth.currentUser!.uid;
      console.log(
        `Loading plugin package.json from: ${process.env.VUE_APP_COMPONENTS}/../../../package.json`
      );

      this.pluginPackage =
        require(`${process.env.VUE_APP_COMPONENTS}/../../../package.json`)?.zoomsense;
    } catch (e) {
      this.$q.notify({
        type: "negative",
        message: (e as any).message,
      });
    }
    this.loading = false;
  },
  computed: {
    noExports(): boolean {
      return (Object.keys(this.$options.components ?? {}).length > 0)
        && (Object.keys(this.pluginPackage?.exports ?? {}).length === 0);
    },
  },
  methods: {
    hasComp(name: string) {
      return (
        this.$options.components?.[name] &&
        this.pluginPackage?.exports?.includes(name)
      );
    },
  },
});
</script>

<style src='animate.css/animate.css'>
/* global styles */
</style>

<style lang='scss'>
.widescreen {
  width: 1280px;
  height: 720px;
  outline: 2px red solid;
  background: white;
  position: relative;
}
</style>
